<template>
  <div id="wrap">
    <coscine-page-header
      :coscineImage="coscineImage"
      :locale="this.$root.$i18n.locale"
      @changeLocale="changeLocale"
    />
    <div id="FormGeneratorDemo" class="container-fluid app-content">
      <b-row>
        <b-col>
          <b-card>
            <h5>{{ $t('inputHeadline') }}</h5>
            <b-form id="edit_form" @submit.stop.prevent="onSubmit">
              <coscine-form-group :mandatory="true" labelFor="applicationProfile" :label="$t('applicationProfileLabel')">
                <b-form-textarea
                  id="applicationProfile"
                  ref="applicationProfile"
                  rows="25"
                  v-model="form.applicationProfile"
                  :placeholder="$t('applicationProfileLabel')"
                />
              </coscine-form-group>
              <coscine-form-group :mandatory="true" labelFor="applicationProfileId" :label="$t('applicationProfileIdLabel')">
                <b-form-input
                  id="applicationProfileId"
                  v-model="form.applicationProfileId"
                  :placeholder="$t('applicationProfileIdLabel')"
                  required="required"
                />
              </coscine-form-group>
              <coscine-form-group :mandatory="true" labelFor="mimeType" :label="$t('mimeTypeLabel')">
                <b-form-select 
                v-model="form.mimeType" 
                :options="options"
                >
                  <template v-slot:first>
                    <b-form-select-option :value="null" disabled>{{ $t('selectMimeType') }}</b-form-select-option>
                  </template>
                </b-form-select>
              </coscine-form-group>
            </b-form>
          </b-card>
        </b-col>
        <b-col>
          <b-card>
            <h5>{{ $t('formHeadline') }}</h5>
            <FormGenerator
              :key="iteration"
              class="generatedForm"
              :applicationProfileId="applicationProfileId"
              :SHACLDefinition="SHACLDefinition"
              :mimeType="mimeType"
              :languageLocale="$root.$i18n.locale"
              :formData="formData"
              @input="input"
            />
          </b-card>
        </b-col>
        <b-col>
          <b-card>
            <h5>{{ $t('metadataHeadline') }}</h5>
            <pre>{{ JSON.stringify(jsonLdData, null, 4) }}</pre>
          </b-card>
        </b-col>
      </b-row>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import {
  CoscinePageHeader,
  CoscineFormGroup,
  CoscineFormTextarea,
} from '@coscine/component-library';
import '@coscine/component-library/dist/index.css';

import coscineImagePath from './assets/logo-rwth.svg';
import linkWhitePath from './assets/link_white.svg';
import mailGreyPath from './assets/mail_grey.svg';
import phoneGreyPath from './assets/phone_grey.svg';
import faxGreyPath from './assets/fax_grey.svg';

import rdfParser from 'rdf-parse';

let scriptPath = '';
let imageEnabled = false;
if (document.currentScript !== undefined) {
  scriptPath = (document.currentScript as any).src as string;
  imageEnabled = true;
}
const scriptUrl = scriptPath === '' ? '/' : scriptPath.substring(0, scriptPath.indexOf('app.js'));
const rootUrl = scriptPath.indexOf('/js') !== -1 ? scriptUrl.replace('/js', '') : scriptUrl;

import FormGenerator from '@coscine/form-generator';
import '@coscine/form-generator/dist/index.css';
Vue.use(FormGenerator);

export default Vue.extend({
  name: 'formgeneratordemo',
  components: {
    CoscinePageHeader,
    CoscineFormGroup,
    CoscineFormTextarea,
  },
  computed: {
    cssProps(): any {
      return {
        '--linkWhite': 'url(' + rootUrl + linkWhitePath + ') 1px 9px no-repeat',
        '--mailGrey': 'url(' + rootUrl + mailGreyPath + ') 0px 6px no-repeat',
        '--phoneGrey': 'url(' + rootUrl + phoneGreyPath + ') 0px 6px no-repeat',
        '--faxGrey': 'url(' + rootUrl + faxGreyPath + ') 0px 6px no-repeat',
      };
    },
  },
  created() {
    this.getMimeTypes();
  },
  data() {
    return {
      coscineImage: rootUrl + coscineImagePath,
      form: {
        applicationProfile: '',
        applicationProfileId: '',
        mimeType: null,
      },
      formData: {} as any,
      applicationProfileId: '',
      SHACLDefinition: '',
      mimeType: null,
      iteration: 0,
      options: [
        { value: 'application/ld+json', text: 'application/ld+json' },
        { value: 'text/turtle', text: 'text/turtle' },
      ],
      timeout: null as any,
      timeoutId: null as any,
      timeoutMimeType: null as any,
      timeoutInterval: 500,
      jsonLdData: {} as any,
    };
  },
  watch: {
    'form.applicationProfile'() {
      const me = this;
      if (this.timeout) {
        clearTimeout(this.timeout);
      }
      this.timeout = setTimeout(() => {
        me.SHACLDefinition = me.form.applicationProfile;
        me.formData = {};
        me.iteration++;
      }, this.timeoutInterval);
    },
    'form.applicationProfileId'() {
      const me = this;
      if (this.timeoutId) {
        clearTimeout(this.timeoutId);
      }
      this.timeoutId = setTimeout(() => {
        me.applicationProfileId = me.form.applicationProfileId;
        me.iteration++;
      }, this.timeoutInterval);
    },
    'form.mimeType'() {
      const me = this;
      if (this.timeoutMimeType) {
        clearTimeout(this.timeoutMimeType);
      }
      this.timeoutMimeType = setTimeout(() => {
        me.mimeType = me.form.mimeType;
        me.iteration++;
      }, this.timeoutInterval);
    },
    '$root.$i18n.locale'() {
      this.iteration++;
    },
  },
  methods: {
    input(formData: any) {
      const dataObject = this.processDataObject(formData, this.applicationProfileId)
      this.jsonLdData = dataObject;
    },
    changeLocale() {
      if (this.$root.$i18n.locale === 'en') {
        this.$root.$i18n.locale = 'de';
      } else {
        this.$root.$i18n.locale = 'en';
      }
    },
    async getMimeTypes() {
      const contentTypes = await rdfParser.getContentTypes();
      this.options = [];
      for (const contentType of contentTypes) {
        this.options.push({ value: contentType, text: contentType });
      }
    },
    processDataObject(formData: any, applicationProfileId: string) {
      const dataObject = {} as any;
      dataObject['@type'] = applicationProfileId;
      for (const nodeName of Object.keys(formData)) {
        if (formData[nodeName].some((element: any) => element['value'] !== "")) {
          dataObject[nodeName] = [];
          for (const metadataEntry of formData[nodeName]) {
            // skip empty and repeating values for ['@id'] or ['@value']
            if (metadataEntry['value'] !== '') {
              if (metadataEntry['type'] === 'uri' && !dataObject[nodeName].some((element: any) => element['@id'] === metadataEntry['value'])) {
                dataObject[nodeName].push({
                  '@id': metadataEntry['value'],
                  '@type': metadataEntry['datatype']
                });
              } else if (!dataObject[nodeName].some((element: any) => element['@value'] === metadataEntry['value'])) {
                dataObject[nodeName].push({
                  '@value': metadataEntry['value'],
                  '@type': metadataEntry['datatype']
                });
              }
            }
          }
        }
      }
      return dataObject;
    },
  },
});
</script>

<style scoped>
#wrap {
  width: 100%;
}
.list-group-item-action {
  background: var(--linkWhite) !important;
}
#mail.list-group-item-action {
  background: var(--mailGrey) !important;
}
#phone.list-group-item {
  background: var(--phoneGrey) !important;
}
#fax.list-group-item {
  background: var(--faxGrey) !important;
}
.h-divider {
  margin-top: 5px;
  margin-bottom: 10px;
  height: 1px;
  width: 100%;
  border-top: 1px solid #bebbbb;
}

</style>

<style>
body {
  background-color: white;
}
#edit_form .col-form-label {
  font-weight: 700;
}
</style>
